<template>
  <div id="components-layout-demo-basic" class="container" :class="{ mobile: isMobile() }">
    <a-layout>
      <a-layout-sider v-if="!isMobile() || isBar == true" class="sider-bar">
        <div class="logo1" style="height: 20px; text-align: left; padding-left: 20px">
          <h2 style="color: #ffffff; font-size: 3em">
            <a-icon type="ellipsis" />
          </h2>
        </div>
        <a-menu
          theme="dark"
          mode="inline"
          style="background: #000; text-align: left; margin-top: 40px; padding-bottom: 120px;"
          :default-selected-keys="['1']"
        >
          <a-menu-item key="1" @click="goHome">
            <span class="nav-text">Home</span>
          </a-menu-item>
          <a-menu-item key="2" @click="goMood">
            <span class="nav-text">Genres & Mood</span>
          </a-menu-item>
          <a-menu-item key="3" @click="goChart">
            <span class="nav-text">Chart</span>
          </a-menu-item>
          <a-menu-item key="4" @click="goRelease">
            <span class="nav-text">New Release</span>
          </a-menu-item>

          <a-menu-item key="5" @click="goRecent" style="margin-top: 20px">
            <span class="nav-text">Recent Played</span>
          </a-menu-item>
          <a-menu-item key="6" @click="goMood" v-if="isLogged">
            <span class="nav-text">Liked Songs</span>
          </a-menu-item>
          <a-menu-item key="7" @click="goMood">
            <span class="nav-text">Albums</span>
          </a-menu-item>
          <a-menu-item key="8" @click="goArtists">
            <span class="nav-text">Artists</span>
          </a-menu-item>

          <a-menu-item key="10" style="margin-top: 20px" @click="goPaid">
            <span class="nav-text">All sounds</span>
          </a-menu-item>
          <a-menu-item key="11" @click="goSong">
            <span class="nav-text">Songs</span>
          </a-menu-item>
          <a-menu-item key="12" @click="goBeat">
            <span class="nav-text">Beat</span>
          </a-menu-item>
          <a-menu-item key="13" @click="goBGM">
            <span class="nav-text">BGM</span>
          </a-menu-item>

          <a-menu-item key="14" style="margin-top: 20px" @click="goVotingGame">
            <span class="nav-text has-arrow">Voting game</span>
          </a-menu-item>
          <a-menu-item key="15" @click="goFundMe">
            <span class="nav-text has-arrow">Go Fund Me</span>
          </a-menu-item>
          <a-menu-item key="16" @click="goShopping">
            <span class="nav-text has-arrow">Shopping</span>
          </a-menu-item>
          <a-menu-item key="17" @click="goGSMT">
            <span class="nav-text has-arrow">GSMT Management</span>
          </a-menu-item>
        </a-menu>
      </a-layout-sider>
      <a-layout>
        <a-layout-header
          :class="scrolled ? `scrolled` : ``"
          :style="{
            position: 'fixed',
            zIndex: 1,
            width: isMobile() ? '100%' : 'calc(100% - 200px)'
          }"
        >
          <a-icon
            type="left"
            v-if="isMobile() && !isShowSearch"
            @click="goBack"
            style="font-size: 18px;"
            class="d-flex align-items-center"
          />
          <p class="content-name" v-if="isMobile()">{{ currentContentName }}</p>
          <div class="header-btn-group">
            <span @click="goBack" v-if="!isMobile()" class="header-btn">
              <a-icon type="left" />
            </span>
            <span @click="forward" v-if="!isMobile()" class="header-btn">
              <a-icon type="right" />
            </span>
            <!-- <span @click="navbar" v-if="isMobile()"
              style="font-size: 2em"> -->
            <!-- <a-icon type="search"/> -->
            <!-- <a-icon type="menu" />
            </span> -->
          </div>
          <div class="wrap-search">
            <a-input v-if="!isMobile()" class="search-input" placeholder="Search" @pressEnter="onSearch" size="large">
              <a-icon slot="prefix" type="search" style="color: rgba(255, 255, 255, 0.65); font-size: 16px" />
            </a-input>
          </div>
          <div class="mr-auto"></div>
          <ul class="right-btn d-flex align-items-center mb-0" style="list-style: none;">
            <li style="display: inline" @click="register" v-if="!isLogged && !isMobile()">
              <span class="signup-btn">Sign Up</span>
            </li>
            <li style="display: inline;" @click="login" v-if="!isLogged && !isMobile()">
              <span
                class="signin-btn">Log In
              </span>
            </li>
            <li class="li-btn" style="float: right; margin-right:25px" v-if="!isMobile() && isLogged && userInfo.is_artist">
              <a-button class="btn-upgrade" @click="goUpload">Upload</a-button>
              <!-- <a-button class="btn-upgrade ml-2" @click="goArtistRegistration"> + Artist Registration</a-button> -->
            </li>
            <li style="float: right;" v-if="!isMobile() && isLogged">
              <a-dropdown :trigger="['click']">
                <a class="ant-dropdown-link" @click="(e) => e.preventDefault()">
                  <a-avatar class="avatar-user" icon="user" />
                  <a-icon type="down" :style="{ fontSize: '20px', color: '#fff', position: 'absolute', top: '24px' }" />
                </a>
                <a-menu slot="overlay" @click="onClick" style="margin-left: calc(-100% + 50px); margin-top:15px;">
                  <a-menu-item key="profile" @click="goProfile"> Profile</a-menu-item>
                  <a-menu-item key="payment" @click="goArtistRegistration" v-if="!userInfo.is_artist"> Artist Register</a-menu-item>
                  <a-menu-item key="aritst-profile" @click="goArtistProfile" v-if="userInfo.is_artist"> Artist Profile</a-menu-item>
                  <a-menu-item key="payment" @click="goPayment"> Payment</a-menu-item>
                  <!-- <a-menu-item key="login" @click="login">Login</a-menu-item>
                  <a-menu-item key="register" @click="register"> Register</a-menu-item> -->
                  <a-menu-item key="logout" @click="goLogout"> Logout</a-menu-item>
                </a-menu>
              </a-dropdown>
            </li>
            <li class="li-btn d-flex" v-if="isMobile()">
              <!-- <a-button class="btn-upgrade mr-3" @click="goArtistRegistration"> + Artist</a-button> -->
              <a-icon class="icon-setting" type="search" @click="goSearch" v-show="isShowSearch"></a-icon>
            </li>
          </ul>
        </a-layout-header>
        <a-layout-content v-on:scroll="handleScroll()" id="main-layout">
          <router-view />
        </a-layout-content>
        <a-layout-footer
          style="
            background: #282828;
            height: 70px;
            border-top: 2px solid #121212;"
          class="d-flex align-items-center p-0"
          v-if="isMobile()"
        >
          <div
            class="menu"
            style="
              width: 100%;
              display: flex;
              flex-warp: wrap;
              flex-direction: row;
              justify-content: space-between;
            "
          >
            <div class="home" style="align-self: center; padding: 5px" @click="goHome">
              <span style="font-size: 1.2em; color: #ffffff"><a-icon type="home"/></span><br />
              <span style="color: #fff; font-size: 1em;letter-spacing: -0.24px;">Home</span>
            </div>
            <div class="home" style="align-self: center; padding: 5px" @click="goShopping">
              <span style="font-size: 1.2em; color: #ffffff"><a-icon type="shop"/></span><br />
              <span style="color: #fff; font-size: 1em;letter-spacing: -0.24px;">Shopping</span>
            </div>
            <div class="home" style="align-self: center; padding: 5px" @click="goVotingGame">
              <span style="font-size: 1.2em; color: #ffffff"><a-icon type="bar-chart"/></span><br />
              <span style="color: #fff; font-size: 1em;letter-spacing: -0.24px;">Voting</span>
            </div>
            <div class="home" style="align-self: center; padding: 5px" @click="goFundMe">
              <span style="font-size: 1.2em; color: #ffffff"><a-icon type="wallet"/></span><br />
              <span style="color: #fff; font-size: 1em;letter-spacing: -0.24px;">Fund Me</span>
            </div>
            <div class="home" style="align-self: center; padding: 5px" @click="goProfile">
              <span style="font-size: 1.2em; color: #ffffff"><a-icon type="user"/></span><br />
              <span style="color: #fff; font-size: 1em;letter-spacing: -0.24px;">Profile</span>
            </div>
          </div>
        </a-layout-footer>
      </a-layout>
    </a-layout>
    <player />
    <login-form :authType="authType"
      @hideLogin="hideAuth"
      @openRegister="register"
      @callServiceLogin="callServiceLogin"/>
    <register :authType="authType"
      @hideRegister="hideAuth"
      @continueRegister="continueRegister"
      @openLogin="login"/>
    <continue-register :authType="authType"
      :userInfoProp="userInfo"
      @hideRegister="hideAuth"
      @openRegister="register"
      @callServiceLogin="callServiceLogin"/>
  </div>
</template>
<script>
import Player from "./components/Player.vue";
import LoginForm from "./Views/login.vue";
import Register from "./Views/register";
import continueRegister from "./Views/continueRegister.vue";

import service from "./service.js";

export default {
  components: {
    Player,
    LoginForm,
    Register,
    continueRegister
  },
  data: () => ({
    authType: '',
    userInfo: {},
    isLogged: false,
    scrolled: false,
    isBar: false,
    currentContentName: "GrafSound",
    isShowSearch: true
  }),
  watch: {
    $route: {
      handler(newRoute) {
        if (!newRoute) {
          this.isShowSearch = false;
          this.currentContentName = "GrafSound";
          return;
        }

        setTimeout(() => {
          document.querySelector("#main-layout").scrollTop = 0;
        });

        if (newRoute.path === "/home") {
          this.isShowSearch = true;
        } else {
          this.isShowSearch = false;
        }

        switch (newRoute.path) {
          case "/home":
            this.currentContentName = "GrafSound";
            break;
          case "/profile":
            this.currentContentName = "Profile";
            break;
          case "/shopping":
            this.currentContentName = "Shopping";
            break;
          case "/voting":
            this.currentContentName = "Voting";
            break;
          case "/gofundme":
            this.currentContentName = "Go Fund Me";
            break;
          default:
            this.currentContentName = "GrafSound";
            break;
        }
      },
      immediate: true
    },
    "$store.state.app.actionRedirect"(val, oldVal) {
      if (val == oldVal || !val.type) return;
      switch (val.type) {
        case "login":
          this.login();
          break;
        case "register":
          this.register();
          break;
        case "continueRegister":
          this.continueRegister();
          break;
      }
    }
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      } else {
        return false;
      }
    },
    hideAuth() {
      this.authType = '';
    },
    showLN() {
      this.show = false;
      this.show1 = true;
      this.isBar = false;
    },
    showSP() {
      this.show = true;
      this.show1 = false;
      this.isBar = false;
    },
    login() {
      this.authType = 'login';
      this.isBar = false;
    },
    register() {
      this.authType = 'register';
      this.isBar = false;
    },
    continueRegister(data) {
      this.authType = 'continue-register';
      this.userInfo = data;
      this.isBar = false;
    },
    goHome() {
      this.show = false;
      this.show1 = false;
      this.$router.push("/home").catch((err) => {});
      this.isBar = false;
    },

    goMood() {
      this.$router.push("/mood").catch((err) => {});
      this.isBar = false;
    },

    goChart() {
      this.$router.push("/chart").catch((err) => {});
      this.isBar = false;
    },

    goRelease() {
      this.$router.push("/release").catch((err) => {});
      this.isBar = false;
    },

    goPaid() {
      this.show = false;
      this.show1 = false;
      this.$router.push("/sound").catch((err) => {});
      this.isBar = false;
    },

    goSong() {
      this.$router.push("/song").catch((err) => {});
      this.isBar = false;
    },

    goBeat() {
      this.$router.push("/beat").catch((err) => {});
      this.isBar = false;
    },

    goBGM() {
      this.$router.push("/bgm").catch((err) => {});
      this.isBar = false;
    },

    goFundMe() {
      this.$router.push("/gofundme").catch((err) => {});
      this.isBar = false;
    },

    goGSMT() {
      this.$router.push("/gsmt").catch((err) => {});
      this.isBar = false;
    },

    goBack() {
      this.$router.go(-1);
      this.isBar = false;
    },

    forward() {
      this.$router.go(1);
      this.isBar = false;
    },

    goVotingGame() {
      this.show = false;
      this.show1 = false;
      this.$router.push("/voting").catch((err) => {});
      this.isBar = false;
    },

    goShopping() {
      this.show = false;
      this.show1 = false;
      this.$router.push("/shopping").catch((err) => {});
      this.isBar = false;
    },

    goProfile() {
      this.$router.push("/profile").catch((err) => {});
      this.isBar = false;
    },
    goPayment() {
      this.$router.push("/payment").catch((err) => {});
      this.isBar = false;
    },
    goCategory() {
      this.$router.push("/category").catch((err) => {});
      this.isBar = false;
    },
    goLogout() {
      localStorage.removeItem('user');
      localStorage.removeItem('Authorization');

      this.$router.go();
      this.isLogged = false;
      this.isBar = false;
    },
    goArtists() {
      this.$router.push("/artists").catch((err) => {});
      this.isBar = false;
    },
    goSearch() {
      this.$router.push("/search").catch((err) => {});
    },
    goArtistRegistration() {
      this.$router.push("/artist-registration").catch((err) => {});
      this.isBar = false;
    },
    goUpload() {
      this.$router.push("/upload-music").catch((err) => {});
      this.isBar = false;
    },
    goArtistProfile() {
      this.$router.push("/artist-profile").catch((err) => {});
      this.isBar = false;
    },
    onSearch(event) {
      let query = event.target.value;

      this.$router.push(`/search/?query=${query}`);
    },
    onClick() {},
    navbar() {
      if (this.isBar == true) {
        this.isBar = false;
      } else {
        this.isBar = true;
      }
    },
    handleScroll(e) {
      const scroll = document.getElementById("main-layout");
      this.scrolled = scroll.scrollTop > 0;
    },
    goRecent() {
      this.$router.push("recent").catch((err) => {});
      this.isBar = false;
    },
    async callServiceLogin(params) {
      let res = await service.get('/user/login', { params});
      if (!res || !res.data || res.data.code !== 200) return;

      const token = res.data.token;
      let user = res.data.data;

      this.isLogged = true;
      this.$store.commit('app/setUser', user);

      user = JSON.stringify(user);
      localStorage.setItem('user', user);
      localStorage.setItem('Authorization', token);
    },
    async getInitialData() {
      try {
        let res = await service.get("/home/statistics-new");

        let data = res.data && res.data.code === 200 && res.data.data ? res.data.data : [];
        this.convertInitialData(data);
      } catch (error) {
        console.log(error);
      }
    },
    convertInitialData(data) {
      let dataHome = [];
      let dataKey = Object.keys(data);

      dataKey.forEach((item, ind) => {
        let dataPush = {
          id: ind,
          title: '',
          type: '',
          arrow: {
            prev: true,
            next: true
          },
          listData: data[item]
        };
        switch (item) {
          case 'dataGenre':
            dataPush.title = "Genres Music";
            dataPush.type = "playlist";

            // Save data to Vuex
            this.$store.commit('app/setListGenre', data[item]);
            break;
          case 'dataNewSoundTrack':
            dataPush.title = "New Release";
            dataPush.type = "music";
            break;
          case 'dataSoundTrack':
            dataPush.title = "Tracks";
            dataPush.type = "music";
            break;
          case 'dataRecent':
            dataPush.title = "Recent played";
            dataPush.type = "music";
            break;
          case 'dataArtist':
            dataPush.title = "Artists";
            dataPush.type = "artist";

            this.$store.commit('app/setListArtist', dataPush);
            return;
        }
        if (data[item].length && dataPush.title) {
          dataHome.push(dataPush);
        }
      })
      this.$store.commit('app/setInitialData', dataHome);
    },
    checkUser() {
      let user = localStorage.getItem('user');
      let auth = localStorage.getItem('Authorization');

      if (!user || !auth) return;
      user = JSON.parse(user);
      this.isLogged = true;
      this.userInfo = user;

      // Save user data Vuex
      this.$store.commit('app/setUser', user);
    }
  },
  mounted() {
    // Check Login Status
    this.checkUser();
    this.getInitialData();

    if (this.isMobile()) {
      window.addEventListener("beforeinstallprompt", (e) => {
        // Prevent Chrome 67 and earlier from automatically showing the prompt
        e.preventDefault();
        // Stash the event so it can be triggered later.
        let deferredPrompt = e;
        deferredPrompt.prompt();
        // Wait for the user to respond to the prompt
        deferredPrompt.userChoice.then((choiceResult) => {
          if (choiceResult.outcome === "accepted") {
            console.log("User accepted the A2HS prompt");
          } else {
            console.log("User dismissed the A2HS prompt");
          }
          deferredPrompt = null;
        });
      });
    }
  }
};
</script>

<style scoped>
.ant-menu-item {
  font-size: 14px;
  font-weight: 700;
  line-height: 16px;
}
.ant-menu-item-open,
.ant-menu-item-selected,
.ant-menu-item:hover,
.ant-menu-item-active {
  background: none;
}

.ant-menu-item-selected span,
.ant-menu-item:hover span,
.ant-menu-item-active span {
  color: #ffffff;
}

span {
  font-size: 1em;
  color: #929292;
}

#components-layout-demo-basic {
  text-align: center;
  user-select: none;
}

#components-layout-demo-basic .ant-layout-header {
  background: transparent;
  color: #fff;
  display: flex;
  transition: all 0.2s;
  z-index: 2 !important;
}

#components-layout-demo-basic .ant-layout-header {
  background: #121212;
}
#components-layout-demo-basic .ant-layout-header.scrolled {
  box-shadow: 0 0 7px #0005;
}

#components-layout-demo-basic .ant-layout-sider {
  background: #000000;
  color: #fff;
}
#components-layout-demo-basic .ant-layout-sider::-webkit-scrollbar {
  display: none !important;
}

#components-layout-demo-basic .ant-layout-content {
  background: #121212;
  color: #fff;
  overflow-y: scroll;
  padding-top: 60px;
}

#components-layout-demo-basic > .ant-layout {
  margin-bottom: 48px;
  min-height: 100%;
  height: 100%;
  min-width: 100%;
  width: 100%;
  position: fixed;
}

#components-layout-demo-basic > .ant-layout:last-child {
  margin: 0;
}
.signup-btn,
.signin-btn {
  width: 124px;
  height: 38px;
  font-size: 12px;
  line-height: 18px;
  font-weight: 700;
  letter-spacing: 1.76px;
  text-transform: uppercase;
  cursor: pointer;
  border-radius: 500px;
  display: inline-flex;
  align-items: center;
  justify-content: center;
}
.signin-btn {
  background: #fff;
  color: #000;
}
.signup-btn {
  background: transparent;
  color: #fff;
}
.container {
  min-height: 100%;
  height: 100%;
}

.spotify-logo--text {
  margin-left: 30px;
  text-align: center;
}

.right-btn li span {
  cursor: pointer;
}

.nav-text {
  color: gray;
  text-align: left;
}

.continue {
  background: #1db954;
  padding-top: 10px;
  padding-bottom: 10px;
  display: block;
  border-radius: 10px;
  color: #ffffff;
  font-weight: bold;
}

.fb {
  background: #0b9bcf;
  padding-top: 10px;
  padding-bottom: 10px;
  display: block;
  border-radius: 10px;
  color: #ffffff;
  font-weight: bold;
}

.home {
  width: 90px;
  cursor: pointer;
  opacity: 0.6;
}

.home:hover {
  border-radius: 10px;
  opacity: 1;
}

.btn-upgrade {
  background: transparent;
  border: 1px solid #fff;
  color: #fff;
  border-radius: 25px;
}

.btn-upgrade:hover {
  background: transparent;
  color: #fff;
  opacity: 0.9;
  transition: 0.3s;
}

.wrap-search {
  margin-left: 10px;
  width: 275px;
}
.content-name {
  font-weight: 500;
  font-size: 18px;
  line-height: 27px;
  color: #f1f1f1;
  margin-bottom: 0;
  position: absolute;
  left: 50%;
  top: 18px;
  transform: translateX(-50%);
}
</style>
<style>
@import url("https://fonts.googleapis.com/css2?family=Poppins:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800&display=swap");

html,
body {
  font-family: "Poppins", sans-serif !important;
}
.category {
  height: 340px;
}
.icon-setting {
  font-size: 24px;
}
.search-input input {
  border-radius: 25px !important;
}

.ant-menu.ant-menu-dark .ant-menu-item-selected {
  background-color: transparent !important;
  border-left: 3px solid #1db954;
}

.has-arrow {
  padding-left: 25px;
  position: relative;
}

.has-arrow:before {
  content: "";
  display: inline-block;
  width: 10px;
  height: 10px;
  background-image: url("/static/icon/gps.png");
  background-size: cover;
  transform: rotate(90deg) translateX(-50%);
  position: absolute;
  left: 0;
  top: 50%;
}

.header-btn-group {
  display: flex;
  align-items: center;
}

.header-btn {
  background-color: rgba(0, 0, 0, 0.7);
  border-radius: 50%;
  display: inline-flex;
  padding: 6px;
  font-size: 20px !important;
  cursor: pointer;
}

.header-btn:last-child {
  margin-left: 3px;
}
.sider-bar {
  height: 100vh;
  overflow: auto;
}
.ant-avatar.avatar-user {
  width: 40px !important;
  height: 40px !important;
}
.ant-avatar.avatar-user {
  background-color: #87d068;
  margin-right: 10px;
  border-radius: 50% !important;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  font-size: 20px;
  color: #eee;
}

/* Global */
.wrap-btn-gl:hover .btn-play-gl {
  bottom: 10px;
  opacity: 1; 
}
.btn-play-gl {
  background-color: #1db954;
  border-radius: 50%;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  width: 40px;
  height: 40px;
  transition: all 0.3s ease;
  transform: scale(1);
  position: absolute;
  bottom: 0;
  right: 10px;
  padding: 10px;
  opacity: 0;
  box-shadow: 0 8px 8px rgba(0, 0, 0, 0.3);
}
.btn-play-gl:hover {
  transform: scale(1.1);
}
.btn-play-gl i {
  font-size: 20px;
}

/* Mobile style */
.mobile .right .next,
.mobile .right .prev {
  font-size: 18px !important;
}
</style>
